/*
 * txt_gfx.inc
 *
 *  Created: 06.11.2020 18:44:32
 *   Author: N0082
 */ 
;**************************************************************************************************
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; bergabeparameter: Z as pointer to font data in flash memory
setfFONT:
		lpm		r16,Z+
		lpm		r17,Z+
		lpm		r18,Z+			// CharSpace
		sts		(CHAR_SPACE),r18
		movw	r2,ZL
		movw	ZL,r16
setFONT:
		adiw	Z,3	
		lpm		r0,Z+
		sts		(FONT_HIGH),r0
		clr		r1
calc_font_bhigh:
		lsr		r0
		rol		r1		// :2
		lsr		r0
		rol		r1		// :4
		lsr		r0
		rol		r1		// :8
		tst		r1
		breq	store_font_bhigh
		inc		r0
store_font_bhigh:
		sts		(FONT_BYTE_HIGH),r0			; r0 = Char Hhe in Bytes
		lpm		r1,Z+
		sts		(FONT_FIRST_CHAR),r1
		lpm		r1,Z+
		sts		(FONT_CHAR_COUNT),r1
		sts		(pFONT_WIDTH_TABLE+0),ZL
		sts		(pFONT_WIDTH_TABLE+1),ZH
		add		ZL,r1
		adc		ZH,ZERO
		sts		(pFONT_DATA_TABLE+0),ZL
		sts		(pFONT_DATA_TABLE+1),ZH
		movw	ZL,r2
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; bergabeparameter: r16 = Char
draw_char:// r0,r1,r2,r3,r4,r5,r6,r7,r8,r9,r16,r17,r18,r20,XL,XH,YL,YH
		push	ZL
		push	ZH
		push	XL
		push	XH
		push	YL
		push	YH
		lds		r3,(FONT_FIRST_CHAR)
//check_charcode_lowerlimit
		cp		r16,r3				
		brsh	check_charcode_highlimit
		ldi		r16,0x7F
		rjmp	calc_charcode_offset		// char code to low
check_charcode_highlimit:
		lds		r4,(FONT_CHAR_COUNT)
		add		r4,r3
		cp		r4,r16
		brsh	calc_charcode_offset
		ldi		r16,0x7F					// char code to high
calc_charcode_offset:
		sub		r16,r3				// remove control char code to start bei zero
		lds		r2,(FONT_BYTE_HIGH)	// databytes for char
		lds		ZL,(pFONT_WIDTH_TABLE+0)
		lds		ZH,(pFONT_WIDTH_TABLE+1)
		clr		r6
		clr		r7
		mov		r3,r16				// cnt Char
calc_font_data_loop:
		clr		r5
		tst		r3
		breq	load_font_charwhidth
		lpm		r4,Z+
		mul		r4,r2
		movw	r9:r8,r1:r0
		lsr		r1					// :2 = test auf ungerade
		ror		r0					// wenn carry=1 dann ungerade
		rol		r5					// carry in r9
		add		r6,r8				// L-byte char data offset
		adc		r7,r9				// H-byte char data offset
		add		r6,r5				// calc start char data offset
		adc		r7,ZERO				// start char data offset= char data offset * databytes for char
		dec		r3
		rjmp	calc_font_data_loop

load_font_charwhidth:
		lpm		r4,Z+				// charwhidth aus [FONT_WIDTH_TABLE] des zu sendenden Char
		tst		r4					// es exestieren keine Daten fr den Char
		brne	load_font_charwhidth_b
draw_char_abort:
		pop		YH
		pop		YL
		pop		XH
		pop		XL
		pop		ZH
		pop		ZL
		ret
load_font_charwhidth_b:
		sts		(CHAR_BYTE_WIDTH),r4
		lds		r2,(FONT_BYTE_HIGH)	// databytes for char
		mul		r2,r4
		sts		(CHAR_DATA_BYTES+0),r0		; Anzahl Daten Bytes fr den Char
		sts		(CHAR_DATA_BYTES+1),r1
		lds		ZL,(pFONT_DATA_TABLE+0)
		lds		ZH,(pFONT_DATA_TABLE+1)
		add		ZL,r6						// load pointer to char data + char data offset
		adc		ZH,r7						// load pointer to char data + char data offset
		sts		(pFONT_CHAR_DATA+0),ZL
		sts		(pFONT_CHAR_DATA+1),ZH
;##########--------------------------##################
		lds		r0,(CharPosX)				// r0 = Xs
;		lds		r1,(vCharPosXe)				// r1 = Xe
		lds		r2,(CharPosY)				// r2 = Ys
;		lds		r3,(vCharPosYe)				// r3 = Ye
		ldi		r16,(Display_Xsize)			// r16 = Display_Xsize
;		lds		r4,(CHAR_BYTE_WIDTH)		// r4 = Char_Widht
		lds		r5,(vCHAR_SPACE)			// r5 = Char_Space
		lds		r6,(FONT_HIGH)				// r6 = Char_High
draw_char_calc_xs:
; Xs <= Display_Xsize
		cp		r16,r0
		brsh	draw_char_calc_xe
		clr		r0							// Xs = 0
		add		r2,r6						// Ys = Ys + Char_High
draw_char_calc_xe:
		mov		r1,r0						// Xe = Xs
		add		r1,r4						// Xe = Xs + Char_Widht
		add		r1,r5						// Xe = Xs + Char_Widht + Char_Space
; Xe <= Display_Xsize
		cp		r16,r1
		brsh	draw_char_calc_ys
		clr		r0
		add		r2,r6						// Ys = Ys + Char_High
		mov		r1,r0						// Xe = Xs
		add		r1,r4						// Xe = Xs + Char_Widht
		add		r1,r5						// Xe = Xs + Char_Widht + Char_Space
; 2. Xe <= Display_Xsize
		cp		r16,r1
		brlo	draw_char_abort				// -----> ABORT - Char to big
draw_char_calc_ys:
		ldi		r16,(Display_Ysize)			// r16 = Display_Ysize
; Ys <= Display_Ysize
		cp		r16,r2
		brsh	draw_char_calc_ye
		clr		r2							// Ys = 0
draw_char_calc_ye:
		mov		r3,r2						// Ye = Ys
		add		r3,r6						// Ye = Ys + Char_High
; Ye <= Display_Ysize
		cp		r16,r3
		brsh	draw_char_store_xy
		clr		r2
		mov		r3,r2						// Ye = Ys
		add		r3,r6						// Ye = Ys + Char_High
; Ye <= Display_Ysize
		cp		r16,r3
		brlo	draw_char_abort				// -----> ABORT - Char to big
draw_char_store_xy:
		sts		(CharPosX),r0
		sts		(vCharPosXe),r1
		sts		(CharPosY),r2
		sts		(vCharPosY),r2				// to calc Page Address to write Char 8bit in COLUMN
		sts		(vCharPosYe),r3
		mov		XL,r0
		mov		YL,r2		

;		cbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
;		rcall	oled_turn_oriantation

		lds		r24,((txtCOLOR)+0)
		lds		r25,((txtCOLOR)+1)
		lds		r16,((backCOLOR)+0)
		lds		r17,((backCOLOR)+1)
;---------------------------------------------------------------------------------------
// HIER FEHLT NOCH DIE BITSCHUBSEREI DES Y-PIXEL SHIFTS
;---------------------------------------------------------------------------------------
put_char_bits_out:
		lds		ZL,(pFONT_CHAR_DATA+0)
		lds		ZH,(pFONT_CHAR_DATA+1)

		lds		r18,(FONT_HIGH)
		lds		r3,(FONT_BYTE_HIGH)
put_char_bytes_loop:
		ldi		r19,8
		mov		r5,r19
		sub		r18,r19
		brcc	put_char_new_row_byte
		subi	r18,(-8)
		mov		r5,r18
put_char_new_row_byte:
		lds		r2,(CHAR_BYTE_WIDTH)
		rcall	oled_set_page_address
put_char_next_column_byte:
		mov		r19,r5
put_char_next_column_b8:
		lpm		r4,Z+
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~		
put_char_pixel_b8_loop:
		lsr		r4
		brcc	put_char_no_pixel		
put_char_one_pixel:
;SPI write Data							
		sts		(SPI0_DATA),r25								; write DATA PIX COLOR H
;SPI write Data									
		sts		(SPI0_DATA),r24								; write DATA PIX COLOR L
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		rjmp	put_char_pixel_b8_loop_cnt

put_char_no_pixel:
;SPI write Data							
		sts		(SPI0_DATA),r17;ZERO								; write DATA PIX COLOR H [BLACK]
;SPI write Data									
		sts		(SPI0_DATA),r16;ZERO								; write DATA PIX COLOR L [BLACK]
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

put_char_pixel_b8_loop_cnt:
		dec		r19
		brne	put_char_pixel_b8_loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		dec		r2
		brne	put_char_next_column_byte
		dec		r3
		brne	put_char_bytes_loop

;##############################################################################################################################################
;		rcall	oled_set_oriantation
;		sbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 1		--> SPI DEVICE DESELECTED
		lds		r16,(vCharPosXe)
		subi	r16,(-1)
		sts		(CharPosX),r16
		pop		YH
		pop		YL
		pop		XH
		pop		XL
		pop		ZH
		pop		ZL
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_set_oriantation:
;		cbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_SETREMAP)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET REMAP & DATA FORMAT"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)

/*
#if		OLED_DISPLAY_ANGEL == 0
#warning	"OLED_DISPLAY_ANGEL = 0 deg"
		ldi		r16,(0x65)										; write DATA (0x66) -> orientation 0 degree
#elif	OLED_DISPLAY_ANGEL == 90
#warning	"OLED_DISPLAY_ANGEL = 90 deg"
		ldi		r16,(0x66)										; write DATA (0x66) -> orientation 180 degree
#elif	OLED_DISPLAY_ANGEL == 180
#warning	"OLED_DISPLAY_ANGEL = 180 deg"
		ldi		r16,(0x77)										; write DATA (0x66) -> orientation 180 degree
#elif	OLED_DISPLAY_ANGEL == 270
#warning	"OLED_DISPLAY_ANGEL = 270 deg"
		ldi		r16,(0x74)										; write DATA (0x66) -> orientation 180 degree
#else
#undef	OLED_DISPLAY_ANGEL
#define	OLED_DISPLAY_ANGEL	0
#warning	"WRONG DISPLAY ORIANTATION !!!"
#warning	"Set OLED_DISPLAY_ANGEL to 0 deg"
		ldi		r16,(0x65)										; write DATA (0x66) -> orientation 0 degree
#endif
*/
		lds		r0,(ORIANTATION)
		sbrc	r0,0											; Oriantation = 0 deg
		ldi		r16,(0x65)
		sbrc	r0,1											; Oriantation = 90 deg
		ldi		r16,(0x66)
		sbrc	r0,2											; Oriantation = 180 deg
		ldi		r16,(0x77)
		sbrc	r0,3											; Oriantation = 270 deg
		ldi		r16,(0x74)

;SPI write Data
		sts		(SPI0_DATA),r16									; 
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
;		sbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_turn_oriantation:
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_SETREMAP)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET REMAP & DATA FORMAT"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
/*
#if		OLED_DISPLAY_ANGEL == 0
#warning	"OLED_DISPLAY_ANGEL = 0 deg"
		ldi		r16,(0x64)										; write DATA (0x66) -> orientation 0 degree
#elif	OLED_DISPLAY_ANGEL == 90
#warning	"OLED_DISPLAY_ANGEL = 90 deg"
		ldi		r16,(0x67)										; write DATA (0x66) -> orientation 180 degree
#elif	OLED_DISPLAY_ANGEL == 180
#warning	"OLED_DISPLAY_ANGEL = 180 deg"
		ldi		r16,(0x76)										; write DATA (0x66) -> orientation 180 degree
#elif	OLED_DISPLAY_ANGEL == 270
#warning	"OLED_DISPLAY_ANGEL = 270 deg"
		ldi		r16,(0x75)										; write DATA (0x66) -> orientation 180 degree
#else
#undef	OLED_DISPLAY_ANGEL
#define	OLED_DISPLAY_ANGEL	0
#warning	"WRONG DISPLAY ORIANTATION !!!"
#warning	"Set OLED_DISPLAY_ANGEL to 0 deg"
		ldi		r16,(0x64)										; write DATA (0x66) -> orientation 0 degree
#endif
*/
		lds		r0,(ORIANTATION)
		sbrc	r0,0											; Oriantation = 0 deg
		ldi		r16,(0x64)
		sbrc	r0,1											; Oriantation = 90 deg
		ldi		r16,(0x67)
		sbrc	r0,2											; Oriantation = 180 deg
		ldi		r16,(0x76)
		sbrc	r0,3											; Oriantation = 270 deg
		ldi		r16,(0x75)

;SPI write Data
		sts		(SPI0_DATA),r16									; 
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_set_page_address:
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		YL,(SSD1351_CMD_SETCOLUMN)						;  write COMMAND 
		sts		(SPI0_DATA),YL									; "SET COLUMN ADDRESS"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)

		lds		YL,(vCharPosY)
		lds		XH,(vCharPosXe)
		mov		YH,YL
		add		YH,r5
		dec		YH
/*					
#if		OLED_DISPLAY_ANGEL == 0	|| OLED_DISPLAY_ANGEL == 180
;SPI write Data					
		sts		(SPI0_DATA),YL									; write DATA Xpos Start
;SPI write Data						
		sts		(SPI0_DATA),YH									; write DATA Xpos End
#else
;SPI write Data									
		sts		(SPI0_DATA),XL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),XH									; write DATA Xpos End
#endif
*/

		lds		r0,(ORIANTATION)
		sbrc	r0,0
		rjmp	oled_set_page_xy_col_0_180
		sbrc	r0,2
		rjmp	oled_set_page_xy_col_0_180

oled_set_page_xy_col_90_270:
;SPI write Data									
		sts		(SPI0_DATA),XL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),XH									; write DATA Xpos End
		rjmp	oled_set_page_xy_wr_col

oled_set_page_xy_col_0_180:
;SPI write Data									
		sts		(SPI0_DATA),YL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),YH									; write DATA Xpos End
		rjmp	oled_set_page_xy_wr_col


oled_set_page_xy_wr_col:
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		YL,(SSD1351_CMD_SETROW)						;  write COMMAND 
		sts		(SPI0_DATA),YL									; "SET ROW ADDRESS"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)

/*
#if		OLED_DISPLAY_ANGEL == 0	|| OLED_DISPLAY_ANGEL == 180
;SPI write Data									
		sts		(SPI0_DATA),XL									; write DATA Ypos Start
;SPI write Data							
		sts		(SPI0_DATA),XH									; write DATA Ypos End
#else
;SPI write Data									
		sts		(SPI0_DATA),YL									; write DATA Ypos Start
;SPI write Data							
		sts		(SPI0_DATA),YH									; write DATA Ypos End
#endif
*/
		lds		YL,(vCharPosY)

		lds		r0,(ORIANTATION)
		sbrc	r0,0
		rjmp	oled_set_page_xy_row_0_180
		sbrc	r0,2
		rjmp	oled_set_page_xy_row_0_180

oled_set_page_xy_row_90_270:
;SPI write Data									
		sts		(SPI0_DATA),YL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),YH									; write DATA Xpos End
		rjmp	oled_set_page_xy_wr_row

oled_set_page_xy_row_0_180:
;SPI write Data									
		sts		(SPI0_DATA),XL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),XH									; write DATA Xpos End
		rjmp	oled_set_page_xy_wr_row

oled_set_page_xy_wr_row:
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		YL,(SSD1351_CMD_WRITERAM)						;  write COMMAND 
		sts		(SPI0_DATA),YL									; "WRITE DATA TO DRAM"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)

		sts		(vCharPosY),YH
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_write_ape_cstring:
	cbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
	rcall	oled_turn_oriantation
oled_write_ape_cstring_loop:
	ld		r16,Z+
	tst		r16
	breq	oled_write_ape_cstring_end
	lds		r0,(CHAR_SPACE)
	ld		r17,Z
	tst		r17
	brne	oled_write_ape_cstring_char
	clr		r0
oled_write_ape_cstring_char:
	sts		(vCHAR_SPACE),r0	
	call	draw_Char
	rjmp	oled_write_ape_cstring_loop
oled_write_ape_cstring_end:
	rcall	oled_set_oriantation
	sbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 1		--> SPI DEVICE DESELECTED
	ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_write_char:
	rcall	setFONT
	cbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
	rcall	oled_turn_oriantation
	call	draw_Char
	rcall	oled_set_oriantation
	sbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 1		--> SPI DEVICE DESELECTED
	ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_write_ape_fstring:
	rcall	setfFONT
	cbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
	rcall	oled_turn_oriantation
oled_write_ape_fstring_loop:
	lpm		r16,Z+
	tst		r16
	breq	oled_write_ape_fstring_end
	lds		r0,(CHAR_SPACE)
	lpm		r17,Z
	tst		r17
	brne	oled_write_ape_fstring_char
	clr		r0
oled_write_ape_fstring_char:
	sts		(vCHAR_SPACE),r0	
	call	draw_Char
	rjmp	oled_write_ape_fstring_loop
oled_write_ape_fstring_end:
	rcall	oled_set_oriantation
	sbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 1		--> SPI DEVICE DESELECTED
	ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
get_cstring_lenght:		; gibt die Anzahl Zeichen eines mit '0' termierten Strings im SRAM zurck
		push	ZH
		push	ZL
		clr		r0
get_cstring_lenght_loop:
		ld		r16,Z+
		tst		r16
		breq	get_cstring_lenght_end
		inc		r0
		rjmp	get_cstring_lenght_loop

get_cstring_lenght_end:
		sts		(cSTRING_CNT),r0
		pop		ZL
		pop		ZH
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_write_ape_cstring_ra:
		movw	r6,Z
		clr		r2
		clr		r3						; CHAR_CNT
get_cstring_pixel_cnt_loop:
		ld		r0,Z+
		tst		r0
		breq	get_cstring_pixel_end	; \0 erreicht
		inc		r3						; CHAR_CNT = CHAR_CNT + 1
		lds		r1,(FONT_FIRST_CHAR)
		sub		r0,r1					; ASCII CHAR - FONT_FIRST CHAR = CHAR_CNT
		movw	Y,Z
		lds		ZL,(pFONT_WIDTH_TABLE+0)
		lds		ZH,(pFONT_WIDTH_TABLE+1)
		add		ZL,r0
		adc		ZH,zero
;get_cchar_picel_cnt_loop:
		lpm		r1,Z+
		add		r2,r1
		movw	Z,Y
		rjmp	get_cstring_pixel_cnt_loop
get_cstring_pixel_end:
		sts		(cSTRING_CNT),r3
		dec		r3
		lds		r4,(CHAR_SPACE)
		mul		r4,r3
		add		r2,r0			
		sts		(cSTRING_PIXEL_CNT),r2
		lds		r0,(CharPosX)
		sub		r0,r2
		sts		(CharPosX),r0
		movw	Z,r6
		rcall	oled_write_ape_cstring
write_cvalue_ra_end:
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_write_ape_fstring_ra:
		movw	r6,Z
		clr		r2
		clr		r3						; CHAR_CNT
get_fstring_pixel_cnt_loop:
		lpm		r0,Z+
		tst		r0
		breq	get_fstring_pixel_end	; \0 erreicht
		inc		r3						; CHAR_CNT = CHAR_CNT + 1
		lds		r1,(FONT_FIRST_CHAR)
		sub		r0,r1					; ASCII CHAR - FONT_FIRST CHAR = CHAR_CNT
		movw	Y,Z
		lds		ZL,(pFONT_WIDTH_TABLE+0)
		lds		ZH,(pFONT_WIDTH_TABLE+1)
		add		ZL,r0
		adc		ZH,zero
;get_fchar_picel_cnt_loop:
		lpm		r1,Z+
		add		r2,r1
		movw	Z,Y
		rjmp	get_fstring_pixel_cnt_loop
get_fstring_pixel_end:
		sts		(cSTRING_CNT),r3
		dec		r3
		lds		r4,(CHAR_SPACE)
		mul		r4,r3
		add		r2,r0			
		sts		(cSTRING_PIXEL_CNT),r2
		lds		r0,(CharPosX)
		sub		r0,r2
		brge	get_fstring_pixel_store_addr
		clr		r0
get_fstring_pixel_store_addr:	
		sts		(CharPosX),r0
		movw	Z,r6
		rcall	oled_write_ape_fstring
write_fvalue_ra_end:
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.macro  fld_txt                      ; ldt den Z-Pointer auf den APE Text mit Header aus Flash
        ldi     ZH,HIGH((@0)*2)
        ldi     ZL,LOW((@0)*2)
.endmacro

.macro  set_xpos                      ; ldt den Z-Pointer auf den APE Text mit Header aus Flash
        ldi     r16,(@0)
        sts		(CharPosX),r16
.endmacro

.macro  set_ypos                      ; ldt den Z-Pointer auf den APE Text mit Header aus Flash
        ldi     r16,(@0)
        sts		(CharPosY),r16
.endmacro

.macro  set_xypos                      ; ldt den Z-Pointer auf den APE Text mit Header aus Flash
        ldi     r16,(@0)
        sts		(CharPosX),r16
		ldi     r16,(@1)
        sts		(CharPosY),r16
.endmacro

.macro  set_txt_color               ; ldt 16Bit @2 nach @1 High und @0 Low	Bsp:	ldi16	r16,r17,(3000)
        ldi     r16,LOW(@0)
        ldi     r17,HIGH(@0)
		sts		((txtCOLOR)+0),r16
		sts		((txtCOLOR)+1),r17
.endmacro

.macro  set_back_color               ; ldt 16Bit @2 nach @1 High und @0 Low	Bsp:	ldi16	r16,r17,(3000)
        ldi     r16,LOW(@0)
        ldi     r17,HIGH(@0)
		sts		((backCOLOR)+0),r16
		sts		((backCOLOR)+1),r17
.endmacro


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~






